void setup()
{
  Serial.begin(9600);
}

const int max_adc = 1023;

const int Switch1 = A1;
const int Switch2 = A2;

class MBclass {
   int sw1mode;
   int sw2mode;
public:
   float scale_factor;
   float max_measured;
   MBclass (float max_measured, int sw1mode, int sw2mode)
   {
      this->max_measured = max_measured;
      this->sw1mode = sw1mode;
      this->sw2mode = sw2mode;
      this->scale_factor = max_measured / (max_adc + 1);
   }
   void set_pinMode()
   {
      pinMode(Switch1, this->sw1mode);
      if (this->sw1mode == OUTPUT) {
          digitalWrite(Switch1, 0);
      }
      pinMode(Switch2, this->sw2mode);
      if (this->sw2mode == OUTPUT) {
          digitalWrite(Switch2, 0);
      }
   }
};

MBclass MB[] = { 
   MBclass( 5.0, INPUT, INPUT ), 
   MBclass( 10.0, OUTPUT, INPUT ),
   MBclass( 20.0, OUTPUT, OUTPUT )
   };

int mb_index = 0;   // messbereichsindex
float scale_factor = MB[mb_index].scale_factor;
float measured;
void loop() {
  int adc_in = analogRead(A0);
  if (adc_in == max_adc) {
    if (mb_index >= (sizeof(MB)/sizeof(MB[0])-1)) {
       Serial.println("OVERFLOW");
    }
    else {
      mb_index++;
      MB[mb_index].set_pinMode();
      scale_factor = MB[mb_index].scale_factor;
    }
  }
  else {
    measured = adc_in * scale_factor;
    Serial.print(measured);
    Serial.println("V");
    if ((mb_index > 0) && (MB[mb_index-1].max_measured > measured)) {
      mb_index--;
      MB[mb_index].set_pinMode();
      scale_factor = MB[mb_index].scale_factor;
    }
  }
}
