// Testrahmen für ein arduino Programm

#include "arduino-simu.h"
#include "arduino-voltmeter-2/arduino-voltmeter-2.ino"

const int sw1 = A1;

int test_in[] = { 526, 1023, 526, 1023, 526, 1023, 100, 200, 526 };
float test_out[] = { 2.56836, -1.0, 5.13672, -1, 10.2734, -1, 1.95312, 1.95312, 2.568 };
int test_mode1[] = { INPUT, OUTPUT, OUTPUT, OUTPUT, OUTPUT, OUTPUT, OUTPUT, INPUT, INPUT };
int main() {
   int tests = 0;
   int errors = 0;
   // tests
   for (int i=0; i<(sizeof(test_in)/sizeof(test_in[0])); i++) {
      tests++;
      simu_analogIn = test_in[i];
      simu_cnt = 0;  // simulator liefert sonst ab dritten mal 1023
      measured = -1;
      loop();
      if (abs(measured - test_out[i]) > 0.001) {
         std::cout << "ERROR: " << test_out[i] << " != " << measured << std::endl;
         errors++;
      }
      if (test_mode1[i] != simu_pinMode[sw1]) {
         std::cout << "ERROR: mode1 " << test_mode1[i] << " != " << simu_pinMode[sw1] << std::endl;
         errors++;
      }
   }
   // summary
   std::cout << std::endl << "-------------" << std::endl;
   if (errors > 0) {
      std::cout << "ERROR. " << errors << " of " << tests 
                << " tests failed." << std::endl;
      return 1;
   }
   std::cout << "OK. " << tests << " passed." << std::endl;
   return 0;
}
